# Отчёт по лабораторной работе №2

Выполнила: студентка гр. ИСЭбд-41 Плаксина Александра.

Вариант программы 1: Формирует файл `/var/result/data.txt` так, что каждая строка файла - количество строк в файлах из каталога `/var/data`.
Вариант программы 2: Ищет наименьшее число из файла `/var/data/data.txt` и сохраняет его третью степень в `/var/result/result.txt`.

## Создание приложений

Создадим 2 приложения.
Был выбран язык C# и технология .NET 7.

Для создания обычных консольных приложений воспользуемся командами:

```sh
dotnet new console -o worker-1
dotnet new console -o worker-2
```
Согласно варианту, программа 1 должна просматривать все файлы в каталоге `/var/data`, считывать количество строк в каждом файле и результат записывать в `/var/result/data.txt`.

[Исходный текст программы worker-1](worker-1/Program.cs)

Согласно варианту программа 2 должна найти наименьшее число из файла `/var/data/data.txt` и сохранить его третью степень в `/var/result/result.txt`.

[Исходный текст программы worker-2](worker-2/Program.cs)

Дополнительно создан файл [.gitignore](.gitignore) для того, чтобы не закоммитить в git ничего лишнего.

## Настройка окружения

Для связи двух приложений воспользуемся следующей схемой:

1. Каталог `./data` должен быть примонтирован в каталог `/var/data` для программы 1.
   Оттуда будут браться исходные данные.
2. Каталог `./result-1` должен быть примонтирован в каталог `/var/result` для программы 2.
   Туда будут складываться промежуточные данные.
3. Каталог `./result-1` также должен быть примонтирован в каталог `/var/data` для программы 2.
   Оттуда будут браться промежуточные результаты.
4. Каталог `./result` должен быть примонтирован в каталог `/var/result` для программы 2.
   Туда будут складывать результаты финальной обработки.

Для каждой программы были созданы файлы Dockerfile ([программа 1](worker-1/Dockerfile), [программа 2](worker-2/Dockerfile)) с подробным описанием процесса сборки.

Был создан файл [docker-compose.yml](docker-compose.yml), в котором указан манифест для запуска распределённого приложения.

## Сборка и запуск

В каталог  `./data` помещены 3 файла с различным количеством строк в каждом файле. В первом файле - 3 строки, во втором - 5 строк, а в третьем - 4 строки

Для запуска приложения необходимо ввести команду `docker compose up ---build`.

Результат запуска после сборки:

![](result.jpg)

В результате в каталоге `./result` создался файл `result.txt` с содержимым `27`, что соответствует входным данным, так как наименьшим числом в нашем случае является `3`.

Изменение значений в файлах из каталога `./data` также изменяет содержимое в файлах из каталогов `./result-1` и `./result`.